
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>WPF+WCF一步一步打造音频聊天室（三）:语音聊天 / iVAN</title>

    <meta name="description" content="WPF+WCF一步一步打造音频聊天室（三）:语音聊天 前一篇文章中实现了文字聊天和共享白板的功能,这篇文章中,我将在前一篇文章的基础上实现语音聊天的功能.语音聊天要比文字聊 天和共享白板难度要大一点. 实现的大概的流程为: 1.一个聊天室成员向另外一个成员发起语音聊天请求 2.这个请求将被送至WCF服务端,WCF的双工通知被邀请人. 3.被邀请人接到通知,他可以选择接受或者拒绝语音聊天的请求. 4.如果拒绝,将通知请求者拒绝语音聊天 5.如果同意,邀请者和被邀请者的客户端将进行语音聊天,此时客户端会开启一个播放声音和接受声音的线程.这里用到了一个开">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">WPF+WCF一步一步打造音频聊天室（三）:语音聊天</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>前一篇文章中实现了文字聊天和共享白板的功能，这篇文章中，我将在前一篇文章的基础上实现语音聊天的功能。语音聊天要比文字聊 天和共享白板难度要大一点。</p>
<p>实现的大概的流程为：</p>
<p>1、一个聊天室成员向另外一个成员发起语音聊天请求</p>
<p>2、这个请求将被送至WCF服务端，WCF的双工通知被邀请人。</p>
<p>3、被邀请人接到通知，他可以选择接受或者拒绝语音聊天的请求。</p>
<p>4、如果拒绝，将通知请求者拒绝语音聊天</p>
<p>5、如果同意，邀请者和被邀请者的客户端将进行语音聊天，此时客户端会开启一个播放声音和接受声音的线程。这里用到了一个开源 的wave类库，在http://www.lumisoft.ee/lswww/download/downloads/Examples/可以下载。声音的通信使用到了UDPClient 类。这个类使 用 UDP 与网络服务通讯。UDP 的优点是简单易用，并且能够同时向多个地址广播消息。UdpClient 类提供了一些简单的方法，用于在阻止 同步模式下发送和接收无连接 UDP 数据报。因为 UDP 是无连接传输协议，所以不需要在发送和接收数据前建立远程主机连接。但您可以 选择使用下面两种方法之一来建立默认远程主机：</p>
<p>*使用远程主机名和端口号作为参数创建 UdpClient 类的实例。</p>
<p>*创建 UdpClient 类的实例，然后调用 Connect 方法。</p>
<p>可以使用在UdpClient 中提供的任何一种发送方法将数据发送到远程设备。使用 Receive 方法可以从远程主机接收数据。</p>
<p>这篇文章使用了Receive 方法从客户端接受数据。然后通过WCF中存储的IP地址，通过Send方法将其发送给客户端。</p>
<p>下面我将在前一篇文章的基础上实现这个语音聊天的功能。首先在客户端添加声音管理的类CallManager，这个类使用到了开源的wave 类库，代码如下：</p>
<p><code>public　class　CallManager<br />
　　　　 {<br />
　　　　　　　　 private　WaveIn　_waveIn;<br />
　　　　　　　　 private　WaveOut　_waveOut;<br />
　　　　　　　　 private　IPEndPoint　_serverEndPoint;<br />
　　　　　　　　 private　Thread　_playSound;<br />
　　　　　　　　 private　UdpClient　_socket;<br />
　　　　　　　　 public　CallManager(IPEndPoint　serverEndpoint)<br />
　　　　　　　　 {<br />
　　　　　　　　　　　　 _serverEndPoint　=　serverEndpoint;<br />
　　　　　　　　 }<br />
　　　　　　　　 public　void　Start()<br />
　　　　　　　　 {<br />
　　　　　　　　　　　　 if　(_waveIn　!=　null　||　_waveOut　!=　null)<br />
　　　　　　　　　　　　 {<br />
　　　　　　　　　　　　　　　　 throw　new　Exception("Call　is　allready　started");<br />
　　　　　　　　　　　　 }<br />
　　　　　　　　　　　　 int　waveInDevice　=　(Int32)Application.UserAppDataRegistry.GetValue("WaveIn",　0);<br />
　　　　　　　　　　　　 int　waveOutDevice　=　(Int32)Application.UserAppDataRegistry.GetValue("WaveOut",　0);<br />
　　　　　　　　　　　　 _socket　=　new　UdpClient(0);　//　opens　a　random　available　port　on　all　interfaces<br />
　　　　　　　　　　　　 _waveIn　=　new　WaveIn(WaveIn.Devices[waveInDevice],　8000,　16,　1,　400);<br />
　　　　　　　　　　　　 _waveIn.BufferFull　+=　new　BufferFullHandler(_waveIn_BufferFull);<br />
　　　　　　　　　　　　 _waveIn.Start();<br />
　　　　　　　　　　　　 _waveOut　=　new　WaveOut(WaveOut.Devices[waveOutDevice],　8000,　16,　1);<br />
　　　　　　　　　　　　 _playSound　=　new　Thread(new　ThreadStart(playSound));<br />
　　　　　　　　　　　　 _playSound.IsBackground　=　true;<br />
　　　　　　　　　　　　 _playSound.Start();<br />
　　　　　　　　 }<br />
　　　　　　　　 private　void　playSound()<br />
　　　　　　　　 {<br />
　　　　　　　　　　　　 try<br />
　　　　　　　　　　　　 {<br />
　　　　　　　　　　　　　　　　 while　(true)<br />
　　　　　　　　　　　　　　　　 {<br />
　　　　　　　　　　　　　　　　　　　　 lock　(_socket)<br />
　　　　　　　　　　　　　　　　　　　　 {<br />
　　　　　　　　　　　　　　　　　　　　　　　　 if　(_socket.Available　!=　0)<br />
　　　　　　　　　　　　　　　　　　　　　　　　 {<br />
　　　　　　　　　　　　　　　　　　　　　　　　　　　　 IPEndPoint　endpoint　=　new　IPEndPoint(IPAddress.Any,　 0);<br />
　　　　　　　　　　　　　　　　　　　　　　　　　　　　 byte[]　received　=　_socket.Receive(ref　endpoint);<br />
　　　　　　　　　　　　　　　　　　　　　　　　　　　　 //　todo:　add　codec<br />
　　　　　　　　　　　　　　　　　　　　　　　　　　　　 _waveOut.Play(received,　0,　received.Length);<br />
　　　　　　　　　　　　　　　　　　　　　　　　 }<br />
　　　　　　　　　　　　　　　　　　　　 }<br />
　　　　　　　　　　　　　　　　　　　　 Thread.Sleep(1);<br />
　　　　　　　　　　　　　　　　 }<br />
　　　　　　　　　　　　 }<br />
　　　　　　　　　　　　 catch　(ThreadAbortException)<br />
　　　　　　　　　　　　 {<br />
　　　　　　　　　　　　 }<br />
　　　　　　　　　　　　 catch<br />
　　　　　　　　　　　　 {<br />
　　　　　　　　　　　　　　　　 this.Stop();<br />
　　　　　　　　　　　　 }<br />
　　　　　　　　 }<br />
　　　　　　　　 void　_waveIn_BufferFull(byte[]　buffer)<br />
　　　　　　　　 {<br />
　　　　　　　　　　　　 lock　(_socket)<br />
　　　　　　　　　　　　 {<br />
　　　　　　　　　　　　　　　　 //todo:　add　codec<br />
　　　　　　　　　　　　　　　　 _socket.Send(buffer,　buffer.Length,　_serverEndPoint);<br />
　　　　　　　　　　　　 }<br />
　　　　　　　　 }<br />
　　　　　　　　 public　void　Stop()<br />
　　　　　　　　 {<br />
　　　　　　　　　　　　 if　(_waveIn　!=　null)<br />
　　　　　　　　　　　　 {<br />
　　　　　　　　　　　　　　　　 _waveIn.Dispose();<br />
　　　　　　　　　　　　 }<br />
　　　　　　　　　　　　 if　(_waveOut　!=　null)<br />
　　　　　　　　　　　　 {<br />
　　　　　　　　　　　　　　　　 _waveOut.Dispose();<br />
　　　　　　　　　　　　 }<br />
　　　　　　　　　　　　 if　(_playSound.IsAlive)<br />
　　　　　　　　　　　　 {<br />
　　　　　　　　　　　　　　　　 _playSound.Abort();<br />
　　　　　　　　　　　　 }<br />
　　　　　　　　　　　　 if　(_socket　!=　null)<br />
　　　　　　　　　　　　 {<br />
　　　　　　　　　　　　　　　　 _socket.Close();<br />
　　　　　　　　　　　　　　　　 _socket　=　null;<br />
　　　　　　　　　　　　 }<br />
　　　　　　　　 }<br />
　　　　 }</code></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-14 04:42:38</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%96%b9%e6%b3%95/" title="方法">方法</a>, <a href="https://www.iamivan.net/tag/socket/" title="socket">socket</a>, <a href="https://www.iamivan.net/tag/private/" title="private">private</a>, <a href="https://www.iamivan.net/tag/%e8%af%b7%e6%b1%82wpf%e4%b8%bb%e8%bf%9b%e7%a8%8b%e9%80%9a%e7%9f%a5/" title="请求wpf主进程通知">请求wpf主进程通知</a>, <a href="https://www.iamivan.net/tag/udp%e8%81%8a%e5%a4%a9%e7%a8%8b%e5%ba%8f/" title="udp聊天程序">udp聊天程序</a>, <a href="https://www.iamivan.net/tag/%e7%8e%af%e4%bf%a1_%e8%81%8a%e5%a4%a9%e6%98%be%e7%a4%ba/" title="环信&lowbar;聊天显示">环信&lowbar;聊天显示</a>, <a href="https://www.iamivan.net/tag/playsound/" title="playsound">playsound</a>, <a href="https://www.iamivan.net/tag/udpclient-%e9%80%9a%e8%ae%af/" title="udpclient 通讯">udpclient 通讯</a>, <a href="https://www.iamivan.net/tag/socket%e8%81%8a%e5%a4%a9/" title="socket聊天">socket聊天</a>, <a href="https://www.iamivan.net/tag/%e8%af%ad%e9%9f%b3%e5%8f%91%e9%80%81/" title="语音发送">语音发送</a>, <a href="https://www.iamivan.net/tag/udpclient/" title="UdpClient">UdpClient</a>, <a href="https://www.iamivan.net/tag/lumisoft/" title="lumisoft">lumisoft</a>, <a href="https://www.iamivan.net/tag/wavein/" title="wavein">wavein</a>, <a href="https://www.iamivan.net/tag/waveout/" title="waveout">waveout</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>WPF+WCF一步一步打造音频聊天室（三）:语音聊天的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bo60rEz.html" rel="bookmark">WPF&plus;WCF一步一步打造音频聊天室（一）：概述</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前几天在老徐的MSN群中聊WCF.我突然想到了用WPF和WCF来打造音频聊天室这么一个轮子.其实是这样的,我在的公司是两岸三地合作 开发的.两岸是指大陆和台湾,三地是指深圳.台北.高雄.由于公司很小,所以一切都要节约成本,当然特别是我们深圳的开发团队, 目前只有3个人,其中两个开发人员,一个Leader.现在我们两岸三地之间的沟通就是使用skype的,因为貌似其他的软件都要有软硬件的 支持.skype只要每个成员有个带麦克风的耳机就行了. 平时,我们深圳这边讨论问题,有一个很大的白板可以一边讲,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDA56lb.html" rel="bookmark">WPF&plus;WCF一步一步打造音频聊天室（四）：视频会话</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前面三篇文章中,我实现了音频聊天室的部分功能,包括:文字聊天,共享白板,语音聊天.这篇文章我将叙述一下视频会话实现的技 术要点. 在Silerlight4中已经集成了摄像和采集声音的功能,但是在WPF4中却没有直接可以用的的控件,由此也可以看出,由桌面程序走向web 程序的大趋势.如果你想用Silverlight实现类似的音频聊天室,下面我列出一些资料供你参考. 1. Your First Step to the Silverlight Voice/Video Chatting Client/S			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b24Dqvp.html" rel="bookmark">一步一步用jenkins，ansible，supervisor打造一个web构建发布系统</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				新blog地址:http://hengyunabc.github.io/deploy-system-build-with-jenkins-ansible-supervisor/ 一步一步用jenkins,ansible,supervisor打造一个web构建发布系统. 本来应该还有gitlab这一环节的,但是感觉加上,内容会增加很多.所以直接用github上的spring-mvc-showcase项目来做演示. https://github.com/spring-projects/spring-			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3rlvkz.html" rel="bookmark">三步教你打造非主流照片效果</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				三步教你打造非主流照片,今天是用最简单的方法快速的用ps把照片制作成非主流效果照片的教程了. 好了来看制作教程吧.用减淡工具,如下图设置. 再对MM脸进行一下下,如上图.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mr0X4Oz.html" rel="bookmark">一步一步学Silverlight ：数据与通信之WCF</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 Silverlight 2 Beta 1版本发布了,无论从Runtime还是Tools都给我们带来了很多的惊喜,如支持框架语言Visual Basic, Visual C#, IronRuby, Ironpython,对JSON.Web Service.WCF以及Sockets的支持等一系列新的特性.&lt;一步一步学Silverlight 2系列&gt;文章将从Silverlight 2基础知识.数据与通信.自定义控件.动画.图形图像等几个方面带您快速进入Silverlight 2开发. 本文将简			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8kdm9M.html" rel="bookmark">大流量网站性能优化：一步一步打造一个适合自己的BigRender插件（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				BigRender 当一个网站越来越庞大,加载速度越来越慢的时候,开发者们不得不对其进行优化,谁愿意访问一个需要等待 10 秒,20 秒才能出现的网页呢? 常见的也是相对简单易行的一个优化方案是 图片的延迟加载.一个庞大的页面,有时我们并不会滚动去看下面的内容,这样就浪费了非首屏部分的渲染,而这些无用的渲染,不仅包括图片,还包括其他的 DOM 元素,甚至一些 js/css(某些js/css 是根据模块请求的,比如一些 ajax),理论上,每增加一个 DOM,都会增加渲染的时间.有没有办法能使得			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOXqd9b.html" rel="bookmark">新手站长培训，一步一步打造站长第三期培训</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断淘宝客 站长团购 云主机 技术大厅 本站将在9月21日,举行第三次完全新手站长培训讲座.qq群:47012513   只接受完全新手.站长老鸟们,请把位置让出来.给新手更多的机会.预计时间,9月21日晚 7:30- 10点.  请相互转告.    本讲座为免费培训,admin5 站长亲自讲座.计划内容是:   国内站长的过去,现在,和未来参考   怎么做站长,需要什么条			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN7Qwyp.html" rel="bookmark">一步一步学Silverlight ：使用样式封装控件观感</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 Silverlight 2 Beta 1版本发布了,无论从Runtime还是Tools都给我们带来了很多的惊喜,如支持框架语言Visual Basic, Visual C#, IronRuby, Ironpython,对JSON.Web Service.WCF以及Sockets的支持等一系列新的特性.&lt;一步一步学Silverlight 2系列&gt;文章带您快速进入Silverlight 2开发. 本文为系列文章第八篇,主要介绍在Silverlight中使用Style元素封装控件观感 Silv			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwWAmWz.html" rel="bookmark">一步一步学习SignalR进行实时通信&lowbar;9&lowbar;托管在非Web应用程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:一步一步学习SignalR进行实时通信_9_托管在非Web应用程序 一步一步学习SignalR进行实时通信\_9_托管在非Web应用程序 一步一步学习SignalR进行实时通信_9_托管在非Web应用程序 前言 部署在控制台应用程序 安装自托管包 安装跨域包 winform客户端 设计界面 连接 完整实现效果 windows服务 创建服务 安装服务 启动服务 连接服务 结束语 源码下载 参考文献 前言 本章我们将学习将signalr服务托管在非web应用程序.之前我们一直是通过IIS部署s			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgKj3M.html" rel="bookmark" class="title">DataBinder&period;Eval和Container&period;DataItem有什么区别</a>
					<div>
						DataGrid控件,在ItemTemplate显示数据时, DataBinder.eval_r(Container.DataItem,&quot;Name&quot;)和Container.Data ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MWZA7b.html" rel="bookmark" class="title">实现IT创业的十三种模式分析</a>
					<div>
						模式一:要有超乎常人的技术发展和市场需求的洞察力. 支持案例:几乎所有大的成功IT企业必备的成功要素. 模式二:在产品推广初期,不要太在意盈利问题,新开拓的市场的培育和市场分额的大面积占领才是最重要的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOxe3b.html" rel="bookmark" class="title">Fireworks动画类型及制作详解</a>
					<div>
						详解 我一直认为FW比之PS强大的地方主要体现在两点上,一是向量图形编辑模式与位图编辑模式的完美整合, 二就是纯图形处理功能与GIF动画制作功能的整合.至于说在软件的使用简便性上的对比,我现在到觉得无 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNnKZb.html" rel="bookmark" class="title">python 远程统计文件代码分享</a>
					<div>
						  享一个Python获取远程文件大小的函数代码,简单实用,是学习Python编程的基础实例. python 远程统计文件 ? 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42ZQJM.html" rel="bookmark" class="title">&lbrack;python爬虫&rsqb;scrapy&plus;django&plus;mysql爬大众点评餐厅数据</a>
					<div>
						环境 python 3.6(推荐使用anaconda) django 1.11(pip install django) scrapy 1.3.3 (pip install scrapy) mysql  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKkwQdb.html" rel="bookmark" class="title">Android更漂亮的AutoLoadListView吧！</a>
					<div>
						转载请注明出处:http://blog.csdn.net/zhaokaiqiang1992 关于上拉刷新和下拉加载,已经有不少的解决方案了,XListView和PullToRefresh应该是被广为熟 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwLYLWb.html" rel="bookmark" class="title">云计算：中国金融业信息化新途径</a>
					<div>
						近年来,云计算成为国内外理论界和实务界的一个热词.特别是2011年以来,一股云计算的浪潮席卷包括金融业在内的诸多行业领域.云计算是指基于在线相关服务的使用和交付模式,通常涉及通过网络来提供动态.易扩展 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6269b.html" rel="bookmark" class="title">jQuery 翻牌或百叶窗效果&lpar;内容三秒自动切换&rpar;&lowbar;jquery</a>
					<div>
						核心代码: 复制代码 代码如下: $(function(){ var timer = true; //执行向上或向下的开关 var liindex = 0; //LI的索引 var $div = $( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1lOZ3b.html" rel="bookmark" class="title">ios-从文件目录中提取图片</a>
					<div>
						问题描述 从文件目录中提取图片 有一个命名为2的文件,其中有有五个图片:0.png, 1.png, 2.png, 3.png 和 4.png. 要提取出这些图片保存到数组中,代码只提出来一个图片: i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Qv0Jp.html" rel="bookmark" class="title">《嵌入式 Linux应用程序开发标准教程（第2版）》&mdash;&mdash;1&period;2 Linux安装</a>
					<div>
						1.2 Linux安装 有了一个初步的了解后,读者是否想亲自试一下?其实安装Linux是一件很容易的事情,不过在开始安装之前,还需要了解一下在Linux安装过程中可能遇到的一些基本知识以及它与Wind ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVBGmb.html" rel="bookmark" class="title">net-水晶报表（Crystal）在记录选定区域那里怎么根据给的时间计算出是星期几，代码怎么写</a>
					<div>
						问题描述 水晶报表(Crystal)在记录选定区域那里怎么根据给的时间计算出是星期几,代码怎么写					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2R44vb.html" rel="bookmark" class="title">第八届中国云计算大会寻找双创明星：云计算大数据创新创业评选正式启动</a>
					<div>
						近年来,国内云计算大数据领域的技术创新成果不断涌现,创业项目层出不穷,正成为创新创业的重要领域和方向.为了更好地推动云计算大数据创新创业健康发展,由中国云计算技术与产业联盟.中国大数据专家委员会和中国 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRWvYp.html" rel="bookmark" class="title">求ssh 操作数据库实现假删除</a>
					<div>
						问题描述 求ssh 操作数据库实现假删除 实现 页面删除时删除数据 单在数据库中也有 就是查询的时候查询不出来删除的数据 解决方案 所谓假删除,无非就是多一个bool字段表示删除标记.创建的时候默认为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRyjEb.html" rel="bookmark" class="title">我是如何在github企业版本上通过ssrf漏洞导致命令执行的？</a>
					<div>
						本文讲的是我是如何在github企业版本上通过ssrf漏洞导致命令执行的?,在我上一篇文章中,我提到了以后攻击的新目标-github企业版,同样也提到了如何去除混淆的ruby代码,并在其中寻找sql注 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKXk5b.html" rel="bookmark" class="title">c&plus;&plus;-为什么a，b的地址取不到</a>
					<div>
						问题描述 为什么a,b的地址取不到 #include using namespace std; int main() { char ch1='I',ch2='Q'; int n1=1, n2=6; d ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvmPJ6b.html" rel="bookmark" class="title">ZF等常用php框架中存在的问题&lowbar;php技巧</a>
					<div>
						从Zend Framework v0.13版本开始,我就开始学习使用Zend Framework.当时公司的一个项目也恰好用到了Zend Framework.到了0.6的版本之后就再没有关注细节了.前 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB1mo9z.html" rel="bookmark" class="title">如何用jquery实现点击radio选择&OpenCurlyDoubleQuote;多选&rdquo;选项后，最多xx项的maxnum文本框成为必填&quest;</a>
					<div>
						问题描述 如何用jquery实现点击radio选择&quot;多选&quot;选项后,最多xx项的maxnum文本框成为必填? 如何用jquery实现点击radio选择&quot;多选&quot;选项 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE4qLLz.html" rel="bookmark" class="title">Idea的一些调试技巧</a>
					<div>
						程序员的工作内容,除了大部分时间写代码之外,因为有不少的时间是用在调试代码上.甚至说不是在调试代码,就是即将调试代码. :) 今天我们来谈谈调试代码的一些技巧,在使用IDE提供的debugger时一些 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJANP8p.html" rel="bookmark" class="title">如何才能避开速赢陷阱？</a>
					<div>
						转变角色的新领导如何才能避开速赢陷阱?当然,这并不是说要放弃早日做出成绩的努力.事实上,我们的分析证实,那些成功完成角色转换的领导者,恰恰是能够坚定不移地争取早日取得成就的领导者,只不过他们关注的是另 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJAXX2p.html" rel="bookmark" class="title">用户群体画像功能深度解析</a>
					<div>
						所有伟大的产品,都离不开用户的追随与期待. 用户群体画像是产品用户增长的利器之一--它能够帮您探究产品指标数字背后的原因. 通过用户群体画像,我们已经能够持续的监测产品运营状况,比如:观察产品关键指标 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdyBx3z.html" rel="bookmark" class="title">解读光网络发展方向：引入SDN 重塑光网络建设</a>
					<div>
						在光网络建设方面,运营商正面临着网络建设日趋复杂,运营维护.管理压力与日剧增的挑战.网络与业务结合更为紧密,网络的变化如何跟上业务需求的变化?如何有效降低网络的复杂程度?这一系列问题亟待解决.SDN所 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDny8BM.html" rel="bookmark" class="title">《 FreeSWITCH权威指南》&mdash;&mdash;2&period;3　PBX与中继线</a>
					<div>
						2.3 PBX与中继线 用户或企业PBX要想打通外面的电话,或者外面的电话需要打进来,需要走运营商提供的中继线,以接入到PSTN网上去.理解中继线的概念对于理解PBX以及PSTN是非常重要的,中继的接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pX05Qyp.html" rel="bookmark" class="title">C&sol;C&plus;&plus;&sol;OC自测题</a>
					<div>
						C++: 1.String 的具体实现 已知String类定义如下: class String {     public:     String(const char *str = NULL); // ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baBAW2M.html" rel="bookmark" class="title">调用接口传送数据，封装成xml</a>
					<div>
						问题描述 调用接口传送数据,封装成xml 现在我要调用别人的接口,把我的数据封装成xml格式,传递给他们, 问题是怎么封装成xml格式,在java后台怎么封装?求解 解决方案 java 应该有创建xm ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRgyOp.html" rel="bookmark" class="title">接口-服务端如何确保请求来自对应的客户端？</a>
					<div>
						问题描述 服务端如何确保请求来自对应的客户端? 我是服务端,现在我需要知道哪些请求是从我们的客户端过来的,哪些是非法的 之前考虑过在请求接口里面加签名摘要之类的,但是android会被解压能看到对应的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW71BrM.html" rel="bookmark" class="title">金利来皮尔卡丹皮具上黑榜或影响人身健康</a>
					<div>
						南方日报讯 金利来皮带.阳光屋银包.皮尔卡丹银包.保兰德拉杆箱等18种皮具产品有问题.昨天省质监局公布最新广东产皮具产品质量抽查结果显示,有近一成产品不合格.据介绍,此次抽查中发现CHARRIOL银包 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYWGrb.html" rel="bookmark" class="title">如何创建ajax对象并兼容多个浏览器&lowbar;AJAX相关</a>
					<div>
						这篇文章主要介绍了如何创建ajax对象并兼容多个浏览器,需要的朋友可以参考下 &lt;script&gt; function createAjax(){ var request=false; //wi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYvLWb.html" rel="bookmark" class="title">Java 测试URL地址是否能正常连接的代码&lowbar;java</a>
					<div>
						Java 测试URL地址是否能正常连接 public static int testWsdlConnection(String address) throws Exception { int stat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYDANb.html" rel="bookmark" class="title">JavaScript 处理Iframe自适应高度&lpar;同或不同域名下&rpar;&lowbar;javascript技巧</a>
					<div>
						1.同域名下Iframe自适应高度的处理 复制代码 代码如下: &lt;iframe onload=&quot;Javascript:SetIFrameHeight(this)&quot; src=& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7QOwaM.html" rel="bookmark" class="title">关于亚马逊MWS API开发的，有在做一块的吗？</a>
					<div>
						问题描述 如题,求一个MWS订单下载的Demo 解决方案 解决方案二:以前上班的公司就是搞AMAZON和EBAY的不过有段时间没搞了解决方案三:218.29.54.234:8081这个公司好像专门做e ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
